import 'dart:async';

import 'package:dynatrace_flutter_plugin/dynatrace_flutter_plugin.dart';
import 'package:dynatrace_flutter_plugin/src/agent/agent_impl.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:mockito/mockito.dart';
import 'package:flutter/services.dart';

import '../util/mock_method_channel.dart';
import '../widget.dart';

void main() {
  late MockMethodChannel methodChannel;
  late Timer timeout;

  setUp(() {
    methodChannel = MockMethodChannel();
    when(methodChannel.invokeMapMethod("getAutoStartConfiguration", any))
        .thenThrow(MissingPluginException(
            "No implementation found for method getAutoStartConfiguration on channel"));

    timeout = Timer(const Duration(seconds: 2), () => fail("Test timed out!"));
  });

  tearDown(() {
    // if the test already ended, cancel the timeout
    timeout.cancel();
  });

  testWidgets('Test Error on Startup', (WidgetTester tester) async {
    Dynatrace dynatrace = DynatraceImpl.private(methodChannel);
    await dynatrace.start(const TestMainWidget());
    expect(find.text('Testing Dynatrace'), findsOneWidget);
  });
}
