import 'package:dynatrace_flutter_plugin/src/cli/config/model/config.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  test('Empty YAML File', () {
    Configuration config = Configuration("");
    basicConfigurationCheck(config);

    expect(config.getAndroidConfiguration()!.getConfig(), isNull);
    expect(config.getIosConfiguration()!.getConfig(), isNull);
  });

  test('YAML File with Android Config', () {
    Configuration config = Configuration('android:\n  config: "TEST"');
    basicConfigurationCheck(config);

    expect(config.getAndroidConfiguration()!.getConfig(), "TEST");
    expect(config.getIosConfiguration()!.getConfig(), isNull);
  });

  test('YAML File with empty Android Config', () {
    Configuration config = Configuration("android:");
    basicConfigurationCheck(config);

    expect(config.getAndroidConfiguration()!.getConfig(), isNull);
    expect(config.getIosConfiguration()!.getConfig(), isNull);
  });

  test('YAML File with iOS Config', () {
    Configuration config = Configuration('ios:\n  config: "TEST"');
    basicConfigurationCheck(config);

    expect(config.getAndroidConfiguration()!.getConfig(), isNull);
    expect(config.getIosConfiguration()!.getConfig(), "TEST");
  });

  test('YAML File with empty iOS Config', () {
    Configuration config = Configuration("android:");
    basicConfigurationCheck(config);

    expect(config.getAndroidConfiguration()!.getConfig(), isNull);
    expect(config.getIosConfiguration()!.getConfig(), isNull);
  });
}

void basicConfigurationCheck(Configuration config) {
  expect(config.getAndroidConfiguration(), isNotNull);
  expect(config.getIosConfiguration(), isNotNull);
}
