import 'package:flutter/services.dart';
import 'package:mockito/mockito.dart';

class MockMethodChannel extends Mock implements MethodChannel {
  @override
  Future<T?> invokeMethod<T>(String? method, [dynamic arguments]) async {
    return super
        .noSuchMethod(Invocation.method(#invokeMethod, [method, arguments]));
  }

  @override
  Future<Map<K, V>?> invokeMapMethod<K, V>(String method,
      [dynamic arguments]) async {
    return super.noSuchMethod(
        Invocation.method(#invokeMapMethod, [method, arguments]),
        returnValue: Future.value(<K, V>{}),
        returnValueForMissingStub: Future.value(<K, V>{})) as dynamic;
  }
}
